OBJ
  sys : "sysdefs"

CON
  _clkmode = xinput
  _clkfreq = 0


  pSPI_engine_cog     = sys#SPI_engine_cog
  pSPI_command        = sys#SPI_command
  pSPI_block_index    = sys#SPI_block_index
  pSPI_buffer_address = sys#SPI_buffer_address

DAT
  SpinReboot long $20_35_06_37 ' bytecode sequence for Spin reboot

PUB LoadFile(argc, argv, argsize, sector, size) | index, cogspi, dbase, vbase, argv1
  cogspi := long[pSPI_engine_cog] - 1

  ' Copy the arg list to just before this object
  argv1 := sys#start - argsize
  bytemove(argv1, argv, argsize)

  ' Fix the argv pointers
  repeat index from 0 to argc - 1
    long[argv1][index] += argv1 - argv

  ' Read the program into memory
  repeat (size + 511) >> 9
    long[pSPI_block_index] := sector++
    long[pSPI_buffer_address] := result
    long[pSPI_command] := "r"
    repeat while long[pSPI_command] == "r"
    if long[pSPI_command] < 0
      reboot
    result += 512

  ' Release the SD card
  long[pSPI_command] := "z"
  repeat while long[pSPI_command] == "z"

  ' Stop the SPI cog
  cogstop(cogspi)

  ' Get VBASE and DBASE
  vbase := word[8]
  dbase := word[10]

  ' Clear VAR area
  bytefill(vbase, 0, dbase - vbase)

  ' Set up the stack
  word[dbase][-4] := 2           ' pbase
  word[dbase][-3] := 0           ' vbase
  word[dbase][-2] := 0           ' dbase
  word[dbase][-1] := @SpinReboot ' pcurr - address of Spin reboot code
  long[dbase]~                   ' Zero result
  long[dbase][1] := argc         ' argc parm
  long[dbase][2] := argv1        ' argv parm

  ' Start app in cog 0
  coginit(0, $f004, 4)

  ' Stop this cog if we are still runnning
  cogstop(cogid)
