'******************************************************************************
' Copyright (c) 2011, 2012, Dave Hein
' See end of file for terms of use.
'******************************************************************************
CON
  _clkmode = xinput
  _xinfreq = $4E495053 ' SPIN

OBJ
  c : "clib_os"

DAT
  longlist long 0
  argi long 0
  total long 0
  numfiles long 0

PUB main(argc, argv)
  total := 0
  numfiles := 0
  argi := 1
  longlist := 0
  if argc => 2 AND byte[long[argv][1]] == "-"
    argi++
    if strcomp(long[argv][1], string("-l"))
      longlist := 1
    else
      usage
  if argi => argc
    listfiles(string("."))
    c.exit(1)
  repeat while argi < argc
    listfiles(long[argv][argi++])

PUB ConvertToLower(ptr) | val
   repeat while val := byte[ptr]
     if (val => "A") and (val =< "Z")
       byte[ptr] := val + 32
     ptr++
     
PUB listfiles(path) | handle, filesize, attrib, astr[2], aptr, pdirent
  handle := c.opendir(path)
  ifnot handle
    c.printf1(string("Could not find %s\n"), path)
    return
  repeat while (pdirent := c.readdir(handle))
    filesize := long[pdirent][0]
    attrib := long[pdirent][1]
    total += filesize
    aptr := @astr
    c.strcpy(aptr, string("drwx"))
    ifnot attrib & $10
      byte[aptr] := "-"
    if attrib & 1
      byte[aptr][2] := "-"
    ifnot attrib & $20
      byte[aptr][3] := "-"
    ConvertToLower(pdirent + 8)
    if longlist
      c.printf3(STRING("%s %6d %s\n"), @astr, filesize, pdirent + 8)
    else
      c.printf1(string("%s\n"), pdirent + 8)
    numfiles++
  if longlist
    c.printf2(STRING("%6d files, %d bytes\n"), numfiles, total)
  c.closedir(handle)

PUB usage
  c.printf0(string("ls [-l] [file list]\n"))
  c.exit(2)

{{
+-----------------------------------------------------------------------------+
|                       TERMS OF USE: MIT License                             |
+-----------------------------------------------------------------------------+
|Permission is hereby granted, free of charge, to any person obtaining a copy |
|of this software and associated documentation files (the "Software"), to deal|
|in the Software without restriction, including without limitation the rights |
|to use, copy, modify, merge, publish, distribute, sublicense, and/or sell    |
|copies of the Software, and to permit persons to whom the Software is        |
|furnished to do so, subject to the following conditions:                     |
|                                                                             |
|The above copyright notice and this permission notice shall be included in   |
|all copies or substantial portions of the Software.                          |
|                                                                             |
|THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR   |
|IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,     |
|FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE  |
|AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER       |
|LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,|
|OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE|
|SOFTWARE.                                                                    |
+-----------------------------------------------------------------------------+
}}
